﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Event: Click(SelectedItem As String)

Private Sub Class_Globals
	
	       'These variables will be used elsewhere in the code
								'and need to be global.
								Private cCallback As Object
								Private cEventName As String

								'The star of this example :)
								Private floatingButton As Button
								
								'The items will be added to this listview
								'which we will make look like a menu.
								Private floatingList As ListView
								
								'Add a gesture detector to swipe and show/hide the 
								'CustomFloatingMenuButton.
								Private GDetector As GestureDetector
								Private GesturePanel As Panel
								Private GestureDirection As Float

								'Here we will save the state of the FMB.
								'True = On screen, False = Hidden
								Private IsFMBShow As Boolean
								
								'NineOldAndroids animation stuff.
								Private MenuAnimationOpen As noaObjectAnimator	
								Private MenuAnimationClose As noaObjectAnimator								
				    Private AnimSetOpen As noaAnimatorSet
								Private AnimSetClose As noaAnimatorSet

End Sub

'Initializes the CustomFloatingMenuButton library.
'Parent: Activity (Required).
'Callback: Me (Required).
'EventName: Prefix to be used on the event responses.
Public Sub Initialize(Parent As Activity, Callback As Object, EventName As String)

							cCallback = Callback
							cEventName = EventName
							
							'Set a default color for the button and make it round.
							Private btnDrawable As ColorDrawable
							
							btnDrawable.Initialize(Colors.ARGB(255, 41, 132, 124), 360dip)
							
							'Set the button's properties and add it to the activity.
							floatingButton.Initialize("floatingButton")
							floatingButton.Background = btnDrawable
							floatingButton.Typeface = Typeface.FONTAWESOME
							floatingButton.Text = "" 'burger character
							floatingButton.TextSize = 24
							floatingButton.TextColor = Colors.White
														
							Parent.AddView(floatingButton, 100%x, 100%y - 100dip, 70dip, 70dip)

							'Add the "menu" to the activity.
							floatingList.Initialize("floatingList")
							
							Parent.AddView(floatingList, 100%x - 200dip, floatingButton.Top - 210dip, 200dip, 200dip)
							
							'Let's tweak the listview to make it look like a menu.
							floatingList.TwoLinesAndBitmap.ItemHeight = 50dip
							floatingList.TwoLinesAndBitmap.Label.Height = 40dip
							floatingList.TwoLinesAndBitmap.SecondLabel.Visible = False
							floatingList.TwoLinesAndBitmap.ImageView.Width = 40dip
							floatingList.TwoLinesAndBitmap.ImageView.Height = 40dip
							floatingList.Visible = False
							
							'Here we make the listview divider transparent.
							'By the way, I HATE USING REFLECTION, JAVAOBJECT or INLINE JAVA!!
							'this is one of the things B4A should improve but that's for another rant.
							Private jObject As JavaObject
							
							jObject = floatingList
							
       Private divDrawable As ColorDrawable
							
							divDrawable.Initialize(Colors.Transparent, 0)
       jObject.RunMethod("setDivider", Array(divDrawable))
							
							'Set the gesture panel.
							'(To learn more about gestures check the gesture detector examples posted on the forums)
							GesturePanel.Initialize("")
							GDetector.SetOnGestureListener(GesturePanel, "Gesture")
							
							Parent.AddView(GesturePanel, 100%x - 30dip, 0dip, 30dip, 100%y)

							'Set the FMB animations.
							'(To learn more about animation check the NineOldAndroids examples posted on the forums)
							MenuAnimationOpen.InitializeFloat(floatingButton, MenuAnimationOpen.PROPERTY_TRANSLATION_X, floatingButton.Width, -floatingButton.Width - 30dip, "Open")
				   AnimSetOpen.PlaySequentially(Array As Object(MenuAnimationOpen))
							AnimSetOpen.Interpolator = AnimSetOpen.INTERPOLATOR_ANTICIPATE_OVERSHOOT
							AnimSetOpen.setDuration(500)		
							
							MenuAnimationClose.InitializeFloat(floatingButton, MenuAnimationClose.PROPERTY_TRANSLATION_X, -floatingButton.Width - 30dip, floatingButton.Width, "Closed")
							AnimSetClose.PlaySequentially(Array As Object(MenuAnimationClose))
							AnimSetClose.Interpolator = AnimSetClose.INTERPOLATOR_ANTICIPATE_OVERSHOOT
							AnimSetClose.setDuration(500)

End Sub

'Show the CustomFloatingMenuButton.
Public Sub ShowMenuButton
	
       IsFMBShow = True

							floatingButton.Text = "" 'burger character
							
							AnimSetOpen.Start	

End Sub

'Hide the CustomFloatingMenuButton.
Public Sub HideMenuButton
	
       IsFMBShow = False
							
							floatingButton.Text = "" 'burger character
							floatingList.Visible = False

							AnimSetClose.Start	
	
End Sub

'Returns the state of the CustomFloatingMenuButton.
'True = On Screen, False = Hidden.
Public Sub IsShow As Boolean
	
	      Return IsFMBShow
	
End Sub

'Set the CustomFloatingMenuButton background color.
Public Sub setSetButtonColor(Color As Int)
	
	      floatingButton.Color = Color
							
End Sub

'Set the CustomFloatingMenuButton text color.
Public Sub setSetButtonTextColor(Color As Int)
	
	      floatingButton.TextColor = Color
							
End Sub

'Add an item to the FMB menu.
'Icon: The image to be used as an icon (enter Null for no picture).
'Title: Item name (this will be also the return value).
Public Sub AddMenuItem(Icon As Bitmap, Title As String)

	      If Icon.IsInitialized Then
								
								  floatingList.AddTwoLinesAndBitmap2(Title, "", Icon, Title)

							Else

										floatingList.AddTwoLinesAndBitmap2(Title, "", Null, Title)
											
	      End If

End Sub

'############################
'######### Routines #########
'############################

Private Sub floatingList_ItemClick(Position As Int, Value As Object)
	
					   'Animate the button.
								floatingButton_Click
								
								'Return the value of the menu item to the Activity.
								If SubExists(cCallback, cEventName & "_Click") Then
							
							    CallSubDelayed2(cCallback, cEventName & "_Click", Value)
										
							 End If
	
End Sub

Private Sub floatingButton_Click
	
	       If floatingList.Visible Then
									  
											floatingList.Visible = False
									  
											floatingButton.Text = "" 'burger character
																						
								Else
									  
											floatingList.Visible = True
										 
											floatingButton.Text = "" 'x character
												
	       End If

End Sub

Private Sub Gesture_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean

								If Action = GDetector.ACTION_DOWN Then
								
											GestureDirection = X

								End If
								
								If Action = GDetector.ACTION_MOVE And GestureDirection > X And IsFMBShow = False Then

											ShowMenuButton
											
								End If
								
								If Action = GDetector.ACTION_MOVE And GestureDirection < X And IsFMBShow Then
											
											HideMenuButton
											
								End If								
										       
								Return True
								
End Sub